var list, dot, client;

function fnInitRemoteDB() {
    list = $api.byId('list');
    var template = $api.byId('template');
    dot = doT.template(template.innerHTML);

    client = new Resource(appid, appkey);
};

var isEnd = false,
    skip = 0,
    LIMIT = 5,
    pushStatus;

function fnLoadRemoteDB(table, fields, where, limit, isPull, callback) {
    LIMIT = limit;

    if (isPull) {
        isEnd = false;
        skip = 0;
        if (pushStatus) {
            pushStatus.innerHTML = '上拉显示更多';
        }
    }

    if (isEnd) {
        return;
    }

    var client = new Resource(appid, appkey);
    var table = client.Factory(table);
    table.query({
        "filter": {
            "fields": fields,
            "where": where,
            "skip": skip,
            "limit": LIMIT
        }
    }, function(ret, err) {
        api.refreshHeaderLoadDone();

        skip += LIMIT;

        if (ret.length > 0) {
            fnShowList(ret, isPull);

            fnCacheImage(ret);

            if (callback) {
                callback(ret);
            }
        }

        if (ret.length < LIMIT) {
            if (pushStatus) {
                pushStatus.innerHTML = '木有啦';
            }

            isEnd = true;
        }
    });
};

function fnCacheImage(datas, index) {
    if (!index) {
        index = 0;
    }

    if (datas.length <= index) {
        return;
    }

    if (!datas[index].thumbnail) {
        return;
    }

    api.imageCache({
        url: datas[index].thumbnail.url
    }, function(ret, err) {
        $api.byId('img_' + datas[index].id).src = ret.url;
        fnCacheImage(datas, index + 1);
    });
};

function fnShowList(datas, isPull) {
    if (isPull) {
        list.innerHTML = dot(datas);
    } else {
        list.innerHTML += dot(datas);
    }

    api.parseTapmode();
};
